'//Caedo HTTPd is (C) Steven Dorman 2006 AAR
'//
'//Caedo is based on my server framework ASlate...

'//---------------------------------------------------------------
'// ASlate is a Asyncronys Multi-Threaded Server Framework
'// 
'// It is designed to make it easy to code a server for anything
'// that can be very basic , or very advanced, while being stable
'// and support lots of load at the same time.
'//
'// ASlate was created by Steven Dorman of 0web Inc.
'//----------------------------------------------------------------

Module Caedo
    '//Framework Settings Block
    Public AppName As String = "Caedo"
    Public VersionNumber As String = "V.0.5.1 ALPHA"

    '//Public Threading Variables
    Public _WThread(35) As System.Threading.Thread
    Public WThread(35) As MyThread
    Public WTWorking(35) As Boolean

    '//Public NameSpace Variables
    Public HTDocs As String
    Public IndexPage As String

    Public LocalPort As Integer
    Public AppPath As String = System.Environment.CurrentDirectory
    Public Running As Boolean = True
    Public Compression As Boolean = False

    Public BannedIP(256) As String

    '//Public Socket Declaration
    Public WithEvents MainSocket As New Devshock.Net.SockServer
    Public WithEvents WhosOnline As New System.Timers.Timer

    Sub Main()
        '//Initialize the main application loop

        '//Set the console window title and start the title updater timer
        Console.Title = "Caedo HTTPd " & VersionNumber
        WhosOnline.Interval = 256
        WhosOnline.Start()

        '//Load Main Application Settings
        LoadConf()
        Console.Write("Loaded Configuration files and Banned IP's List.. (1 of 3)" & vbCrLf)

        '//Create the worker threads
        InitThreading()
        Console.Write("Initialized worker threads..                      (2 of 3)" & vbCrLf)

        '//Start the Asyncronus Sockets
        MainSocket.LocalPort = LocalPort
        MainSocket.Capacity = 35
        MainSocket.BufferSize = 8192
        MainSocket.PackageSize = 8192
        MainSocket.StartServer()
        Console.Write("Created Asyncronous Sockets..                     (3 of 3)" & vbCrLf)

        '//Pause before clearing the console
        System.Threading.Thread.Sleep(1000)

        '//Ready the console window
        Console.Clear()
        Console.BackgroundColor = ConsoleColor.DarkGray
        Console.Write(AppName & " " & VersionNumber & vbCrLf)
        Console.ResetColor()

        Console.Write(vbCrLf & "Caedo HTTPd is listening for connections on port " & LocalPort & vbCrLf & vbCrLf)

        '//Beep to let the user know caedo has loaded
        Console.Beep()

        '//Main application loop starts here
        Dim StrText As String
        While Running = True
            '//Take Console Input
            Console.Write(AppName & "  /> ")
            StrText = Console.ReadLine()

            If StrText = "exit" Or StrText = "Exit" Then
                Running = False
            ElseIf StrText = "cls" Or StrText = "Cls" Then
                Console.Clear()
                Console.BackgroundColor = ConsoleColor.DarkGray
                Console.Write(AppName & " " & VersionNumber & vbCrLf)
                Console.ResetColor()
            ElseIf StrText = "reload_cfg" Or StrText = "Reload_cfg" Then
                LoadConf()
                Console.Write("Reloaded Configuration files and Banned IP's List.. " & vbCrLf)
            ElseIf Left(StrText, 11) = "Threadstate" Or Left(StrText, 11) = "threadstate" Then
                Console.Write("Thread #" & Right(StrText, 1) & " State: " & _WThread(Right(StrText, 1)).ThreadState.ToString & vbCrLf)
            End If
        End While

        '//Stop the connection timer
        WhosOnline.Stop()
        WhosOnline.Close()
        WhosOnline.Dispose()
        WhosOnline = Nothing

        '//Make sure the sockets have been cleaned up
        MainSocket.StopServer()
        MainSocket = Nothing

        '//Then we make sure we kill every thread
        KillThreads()

        '//Delete temporary files
        Kill(AppPath & "\data\temp\*.out")

        '//Die
        End

    End Sub

    Private Sub InitThreading()
        '//Create 35 dynamic worker threads for our use
        Dim i As Integer = 0

        For i = 0 To UBound(_WThread)
            '//A new threading class instance
            WThread(i) = New MyThread
            '//And all of its handlers...
            AddHandler WThread(i).TransferComplete, AddressOf TransferComplete
            AddHandler WThread(i).Complete, AddressOf ThreadComplete
            AddHandler WThread(i).ShowError, AddressOf ThreadShowError
            AddHandler WThread(i).IsSleeping, AddressOf IsSleeping
            '//Create the thread, make it in the background, and start it
            _WThread(i) = New System.Threading.Thread(AddressOf WThread(i).ThreadInit)
            '_WThread(i).IsBackground = True
            _WThread(i).Start()
            '//Set the index of the thread in the threadding class
            WThread(i).MyIndex = i
        Next
    End Sub

    Private Sub KillThreads()
        On Error Resume Next
        Dim i As Integer
        For i = 0 To UBound(_WThread)
            Console.Clear()
            Console.Write("Please wait caedo is unloaded from memory...(" & i & ")")
            _WThread(i).Abort()
            _WThread(i) = Nothing
            WThread(i) = Nothing
        Next
    End Sub

    Private Sub TransferComplete(ByVal Index As Integer, ByVal GuidSocket As System.Guid)

    End Sub

    Private Sub ThreadShowError(ByVal E As String, ByVal Index As Integer)
        '//Write any errors wich occured in the worker threads to the log file
        WriteELog("Thread " & Index & " Produced an Error. " & E)
    End Sub

    Private Sub ThreadComplete(ByVal Index As Integer)
        WriteELog("Thread " & Index & " has shutdown. ")
    End Sub

    Private Sub IsSleeping(ByVal Index As Integer)
        System.Threading.Thread.Sleep(512)
        WTWorking(Index) = False
    End Sub

    Private Sub MainSocket_evDataReceived(ByVal sender As Object, ByVal e As Devshock.Net.SockServer.DataReceivedEventArgs) Handles MainSocket.evDataReceived
        On Error GoTo hell
        '//Create the data variable, index variable, and guid variable
        Dim _data As String, i As Integer, _guid As System.Guid
        _data = e.DataReceived
        _guid = e.ConnectionGuid

retry:
        '//Pass onto a thread for parsing
        For i = 0 To UBound(_WThread)
            If WTWorking(i) = False Then
                WThread(i).MyData = _data
                WThread(i).MySocket = _guid
                WTWorking(i) = True
                _WThread(i).Resume()
                Exit For
            End If
        Next

        '//Clean Up
        _data = Nothing
        _guid = Nothing
        i = Nothing

        Exit Sub
hell:
        WriteELog(Err.Description)
    End Sub

    Private Sub MainSocket_evOpenConnection(ByVal sender As Object, ByVal e As Devshock.Net.SockServer.OpenConnectionEventArgs) Handles MainSocket.evOpenConnection

    End Sub

    Private Sub MainSocket_evCloseConnection(ByVal sender As Object, ByVal e As Devshock.Net.SockServer.CloseConnectionEventArgs) Handles MainSocket.evCloseConnection

    End Sub

    Private Sub MainSocket_evClassException(ByVal sender As Object, ByVal e As Devshock.Net.SockServer.ClassExceptionEventArgs) Handles MainSocket.evClassException
        '//On a class exception, write the error to the log file
        WriteELog(e.ClassException.ToString)
    End Sub

    Public Sub WriteELog(ByVal StrText As String)
        On Error Resume Next

        '//Declare Variables
        Dim Free As Integer, FileOut As String
        FileOut = AppPath & "\data\logs\Error.log"
        Free = FreeFile()

        '//Open a file handle, write the line, and close it
        Dim objWriter As New System.IO.StreamWriter(FileOut, True)
        objWriter.Write("[" & Now & "] " & StrText & vbNewLine)
        objWriter.Close()

    End Sub

    Public Sub LoadConf()
        On Error Resume Next

        '//Declare a new IniFile instance
        Dim MyIni As New IniFile(AppPath & "\data\conf\httpd.cfg")
        Dim BipList() As Byte
        Dim BippList As String

        '//Now lets load all the default setting

        HTDocs = MyIni.GetString("main", "htdocs", "")
        HTDocs = Replace(HTDocs, "<apppath>", AppPath)

        LocalPort = MyIni.GetString("main", "port", "")

        IndexPage = MyIni.GetString("main", "indexpage", "")

        Compression = MyIni.GetString("main", "compression", "")

        '//Load the banned ip's list
        BipList = System.IO.File.ReadAllBytes(AppPath & "\data\conf\banned.cfg")
        BippList = System.Text.Encoding.Default.GetString(BipList)

        '//Split it up
        BannedIP = Split(BippList, vbCrLf)

    End Sub

    '//Update Console Caption for every user currently connected
    Private Sub WhosOnline_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles whosonline.Elapsed
        On Error Resume Next

        If MainSocket.CountConnections <> 0 Then
            Console.Title = "Caedo HTTPd " & VersionNumber & "  -  Current Connections: " & MainSocket.CountConnections
        Else
            Console.Title = "Caedo HTTPd " & VersionNumber
        End If

    End Sub
End Module
