Public Class MyThread
    '//Public Events
    Public Event TransferComplete(ByVal Index As Integer, ByVal GuidSocket As System.Guid)
    Public Event Complete(ByVal Index As Integer)
    Public Event ShowError(ByVal E As String, ByVal Index As Integer)
    Public Event IsSleeping(ByVal Index As Integer)

    '//Public Members
    Public Running As Boolean = True
    Public MyIndex As Integer
    Public MyData As String
    Public MySocket As System.Guid

    '//Priavte Members
    Dim UsingGzip As Boolean = False
    Dim UsingDeflate As Boolean = False
    Dim Compressing As Boolean = False

    Public Headers As New Web
    Public Working As Boolean = True

    Public Sub ThreadInit()
        '//PLACE ANY THREAD INIT CODE HER

        '//Call Main thread sub routeine
        Threading()
    End Sub

    Private Sub Threading()
        On Error GoTo hell
        Dim e As String
        '//Main loop of a worker thread
        Do Until Running = False
            If MyData <> Nothing Then
                '//Pass our threads parsing data to the process data function
                e = (ProcessData(MyData, MyIndex, MySocket))

                '//Has an error occured in the processing function?
                If e <> Nothing Then
                    '//If so, raise the error as an ShowError event
                    RaiseEvent ShowError(e, MyIndex)
                End If

                '//Clear our threads parsing data
                MyData = Nothing
                MySocket = Nothing
            End If

            '//Tell the main thread this thread is ready for use
            RaiseEvent IsSleeping(MyIndex)

            '//Suspend this thread until its needed next
            Caedo._WThread(MyIndex).Suspend()
        Loop


        RaiseEvent Complete(MyIndex)
        Exit Sub
hell:

        RaiseEvent Complete(MyIndex)
        RaiseEvent ShowError(Err.Description, MyIndex)
    End Sub

    '//This is the main function to process the threads input data
    Public Function ProcessData(ByVal StrData As String, ByVal IntIndex As Integer, ByVal GuidSocket As System.Guid) As String
        On Error GoTo hell
        Dim RMIP As String
        Dim MyIni As New IniFile(Caedo.AppPath & "\data\conf\vhost.cfg")
        Dim tmp() As String
        Dim i As Integer

        '//Make sure we dont compress when not needed
        UsingGzip = False
        UsingDeflate = False

        '//Gather the remote ip address
        RMIP = Caedo.MainSocket.Item(GuidSocket).RemoteHost.ToString

        '//Parse the headers with the web class
        Headers.PhaseWebHead(StrData)

        '//Patch up the file name so we can find it
        Dim FileOut As String = "", ECode As Integer = 0
        FileOut = Headers.page
        FileOut = Replace(FileOut, "/", "\")
        FileOut = Replace(FileOut, "http://", "")
        FileOut = Replace(FileOut, "%20", " ")

        '//Should we load local, or the virtual host?
        '//I know this is a funny peice of code, could be reworked..
        '//But it works and dosent seem to process slow...
        If MyIni.GetString(Headers.Host, "htdocs", "") = "" Then

            '//Check if index or not for main site
            If FileOut = "\" Then
                FileOut = Caedo.HTDocs & "\" & Caedo.IndexPage
                ECode = 0
            Else
                FileOut = Caedo.HTDocs & FileOut
                ECode = 0
            End If

        Else

            If MyIni.GetString(Headers.Host, "enabled", "") = "1" Then

                '//Check if index or not for virtual host
                If FileOut = "\" Then
                    FileOut = MyIni.GetString(Headers.Host, "htdocs", "") & "\" & MyIni.GetString(Headers.Host, "indexpage", "")
                    ECode = 0
                Else
                    FileOut = MyIni.GetString(Headers.Host, "htdocs", "") & FileOut
                    ECode = 0
                End If

            Else

                '//If this virtual host is diabled, send a unauthorized
                WriteAccess("[" & RMIP & "] Request for disabled VHost - " & FileOut)
                FileOut = Caedo.AppPath & "\data\e_page\403.e_page"
                ECode = 0

            End If
        End If

        '//Check to see if the file exists, if its an error page, dont bother logging it
        If Right(FileOut, 3) <> "age" Then
            If System.IO.File.Exists(FileOut) = False Then
                ECode = 404
                WriteAccess("[" & RMIP & "] 404 File not Found - " & FileOut)
                FileOut = Caedo.AppPath & "\data\e_page\404.e_page"
            Else
                ECode = 0
                WriteAccess("[" & RMIP & "] Request for - " & FileOut)
            End If
        End If

        '//Check to see if we are going to use compression
        '//Currently, some bytes are lost while compression, and i dont know why
        '//So were only going to compress HTML for now... if you know a fix, tell me!
        If GetFileInfo(FileOut) = "text/html" Or Left(GetFileInfo(FileOut), 5) = ".image" Then
            If Caedo.Compression = True Then
                tmp = Split(Headers.Encoding, ",")
                For i = 0 To UBound(tmp)
                    If tmp(i) = "gzip" Then
                        UsingDeflate = True
                        'UsingGzip = True
                        Exit For
                    ElseIf tmp(i) = "deflate" Then
                        UsingDeflate = True
                        Exit For
                    End If
                Next


                i = CompressIt(FileOut)
                System.Threading.Thread.Sleep(500)
                FileOut = Caedo.AppPath & "\data\temp\compressed" & i & ".out"
            End If
        End If

        '//Check to see if this user is banned from the server
        If IsBanned(RMIP) = True Then
            ECode = 403
            WriteAccess("[" & RMIP & "] ** Banned user requested a file - " & FileOut)
            FileOut = Caedo.AppPath & "\data\e_page\403.e_page"
        End If

        '//Call the transfer routene
        Return BeginTransfer(FileOut, ECode, GuidSocket)

        '//Clean up any crap memory
        RMIP = Nothing
        MyIni = Nothing
        FileOut = Nothing
        ECode = Nothing

        Exit Function
hell:
        Return Err.Description
    End Function

    Public Function BeginTransfer(ByVal FileOut As String, ByVal ECode As Integer, ByVal GuidSocket As System.Guid) As String
        On Error GoTo hell

        '//Now we send the file to the browser!
        Dim Free As Integer
        Dim FLen As Long
        Dim W As Long
        Dim TheData(8192) As Byte
        Dim FPack As Boolean = False

        '//Get a free file handle   
        Free = FreeFile()

        '//Open the file for processing
        FileOpen(Free, FileOut, OpenMode.Binary)

        '//store the len of the file
        FLen = LOF(Free)

        '//Loop till end of file. Heres my oh so amazing sending file routene.
        Do Until EOF(Free)
            '//If the packet we are on isnt 8192 bytes, then shrink it
            If W + 8192 > FLen Then
                ReDim TheData(FLen - W - 1)
            End If

            '//Collect the packets data, and update where we are in W
            FileGet(Free, TheData)
            W = W + TheData.Length

            '//Then send the data to the user
            If FPack = False Then
                Caedo.MainSocket.Send(GuidSocket, SendHeaders(FLen, FileOut, , ECode) & System.Text.Encoding.Default.GetString(TheData))
                FPack = True
            Else
                Caedo.MainSocket.Send(GuidSocket, System.Text.Encoding.Default.GetString(TheData))
            End If

        Loop

        System.Threading.Thread.Sleep(256)
        If Caedo.MainSocket.Exists(GuidSocket) = True Then
            Caedo.MainSocket.Send(GuidSocket, ".")
        End If

        '//Close the file handle
        FileClose(Free)

        '//Clean up memory...
        Free = Nothing
        FLen = Nothing
        W = Nothing
        TheData = Nothing
        FPack = Nothing

        Return Nothing
        Exit Function
hell:
        '//Close the file handle
        FileClose(Free)

        Return Err.Description
    End Function

    '//Simple Function to create the headers to be sent to the browser
    '//Not much to explain here
    Private Function SendHeaders(ByRef howbig As Integer, ByRef namer As String, Optional ByRef e_head As String = "", Optional ByRef ECode As Integer = 0) As String
        Dim theheaders As String

        If ECode = 404 Then
            theheaders = "HTTP/1.0 " & ECode & " Not Found"
        ElseIf ECode = 403 Then
            theheaders = "HTTP/1.0 " & ECode & " Unauthorized"
        ElseIf ECode <> 0 Then
            theheaders = "HTTP/1.0 " & ECode & " Error"
        Else
            theheaders = "HTTP/1.0 200 OK"
        End If

        theheaders = theheaders & vbCrLf & "Server: Caedo HTTPd"
        theheaders = theheaders & vbCrLf & "Date: " & Now
        theheaders = theheaders & vbCrLf & "Last-Modified: " & Now
        theheaders = theheaders & vbCrLf & "Accept-Ranges: bytes"
        theheaders = theheaders & vbCrLf & "Content-Length: " & howbig
        theheaders = theheaders & vbCrLf & "Connection: close"
        theheaders = theheaders & vbCrLf & "Content-Type: " & GetFileInfo(namer)

        '//Check to see if were gonna gzip this bitch ( or deflate now )
        If UsingGzip = True Then
            theheaders = theheaders & vbCrLf & "Content-Encoding: gzip"
        ElseIf UsingDeflate = True Then
            theheaders = theheaders & vbCrLf & "Content-Encoding: deflate"
        End If

        '//Send extra headers from cgi, if they are there
        If e_head <> "" Then
            theheaders = theheaders & vbCrLf & e_head
        End If

        theheaders = theheaders & vbCrLf & vbCrLf
        Return theheaders

        theheaders = Nothing
    End Function

    '//Function for finding the MIME Type of the file requested
    Private Function GetFileInfo(ByRef filename As String) As String
        Dim FileType As String = "text/plain", i As Integer

        '//Declare a new inifile instance
        Dim MyIni As New IniFile(Caedo.AppPath & "\data\mime.types")

        '//Loop while reading the mime types..try right > 3 then 4 - 6
        For i = 0 To 6
            FileType = MyIni.GetString("types", Right(filename, i), "")
            If FileType <> "" Or FileType <> Nothing Then
                Exit For
            End If
        Next

        '//If we did not find a known entry in the mimes list, make it binary
        If FileType = Nothing Or FileType = "" Then
            FileType = "unknown/binary"
        End If

        GetFileInfo = FileType
        FileType = Nothing
        i = Nothing
    End Function

    '//A function for writing to the access log
    Private Sub WriteAccess(ByVal StrText As String)
        On Error Resume Next

        '//Declare Variables
        Dim Free As Integer, FileOut As String
        FileOut = Caedo.AppPath & "\data\logs\Access.log"
        Free = FreeFile()

        '//Declare the object for the stream, write the line, and close it
        Dim objWriter As New System.IO.StreamWriter(FileOut, True)
        objWriter.Write(StrText & vbNewLine)
        objWriter.Close()

    End Sub

    '//Basic function for checking to see if a specific IP address is banned
    Private Function IsBanned(ByVal RMIP As String) As Boolean
        Dim i As Integer = 0

        IsBanned = False

        For i = 0 To UBound(Caedo.BannedIP)
            If Caedo.BannedIP(i) = RMIP Then
                Return True
                Exit For
            End If
        Next i

    End Function

    Public Function CompressIt(ByVal StrFile As String) As Integer
        Try
            Dim i As Integer
            i = RandomNumber(0, 50)

            Dim fileout As String = Caedo.AppPath & "\data\temp\compressed" & i & ".out"
            Dim free As Integer

            free = FreeFile()

            '//Delete the file if its already there
            If System.IO.File.Exists(fileout) = True Then
                Kill(fileout)
            End If

            '//Declare the object for the stream, read it all, and close it
            Dim objReader As New System.IO.StreamReader(StrFile, True)
            Dim _tmp As String, tmp As Byte()
            _tmp = objReader.ReadToEnd
            objReader.Close()

            '//Make up for lost bytes....!
            _tmp = _tmp & "     "

            '//Are we gonna gzip it or deflate it
            If UsingGzip = True Then
                tmp = CompressMeGzip(_tmp)
            ElseIf UsingDeflate = True Then
                tmp = CompressMeDeflate(_tmp)
            End If

            FileOpen(free, fileout, OpenMode.Binary)
            FilePut(free, tmp)
            FileClose(free)

            Return i

        Catch ex As Exception

            WriteELog("Compression Error: " & Err.Description)

        End Try
    End Function

    Public Function CompressMeGzip(ByVal StrData As String) As Byte()
        Dim FileStream As New System.IO.MemoryStream
        Dim GZip As New System.IO.Compression.GZipStream(FileStream, System.IO.Compression.CompressionMode.Compress, True)

        Dim Buff As Byte() = System.Text.Encoding.Default.GetBytes(StrData)

        GZip.Write(Buff, 0, StrData.Length)

        Return FileStream.GetBuffer

    End Function

    Public Function CompressMeDeflate(ByVal StrData As String) As Byte()
        Dim FileStream As New System.IO.MemoryStream
        Dim Deflate As New System.IO.Compression.DeflateStream(FileStream, System.IO.Compression.CompressionMode.Compress, True)

        Dim Buff As Byte() = System.Text.Encoding.Default.GetBytes(StrData)

        Deflate.Write(Buff, 0, Buff.Length)

        Return FileStream.GetBuffer

    End Function

    Private Function RandomNumber(ByVal low As Int32, ByVal high As Int32) As Integer
        Static RandomNumGen As New System.Random
        Return RandomNumGen.Next(low, high + 1)
    End Function
End Class
