Option Strict Off
Option Explicit On
Public Class Web


    Private Structure w_head
        Dim mAccept As String
        Dim mRequest As String
        Dim mCookie As String
        Dim mReferer As String
        Dim mPage As String
        Dim mAcceptLan As String
        Dim mHost As String
        Dim mEncoding As String
        Dim mHTTPVer As String
        Dim mAgent As String
        Dim mContentLen As Integer
        Dim mContentRange As Integer
        Dim mFormData As String
        Dim mConnection As String
        Dim mAuthorization As String
    End Structure

    Private WebGet As w_head

    Public Function PhaseWebHead(ByRef Strdata As String) As Boolean
        Dim Base64Str As String = ""
        On Error Resume Next

        Dim iPart, lPart As Short
        iPart = InStr(Strdata, " ")
        WebGet.mRequest = Mid(Strdata, 1, iPart - 1)
        ' now we need to get the requested resource
        lPart = InStr(iPart + 1, Strdata, " ")
        WebGet.mPage = Mid(Strdata, iPart + 1, lPart - iPart - 1)
        WebGet.mFormData = Split(WebGet.mPage, "?")(1)
        WebGet.mPage = Split(WebGet.mPage, "?")(0)

        ' Now we move on to get the HTTP Verision
        iPart = InStr(lPart + 1, Strdata, vbCrLf)
        WebGet.mHTTPVer = Trim(Mid(Strdata, lPart, iPart - lPart))
        ' Now we will move on to get the clients Agent
        iPart = InStr(1, Strdata, "User-Agent:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        WebGet.mAgent = Trim(Mid(Strdata, iPart + 11, lPart - iPart - 11))
        ' Now we need to get the host name
        iPart = InStr(1, Strdata, "Host:", CompareMethod.Text)
        lPart = InStr(iPart + 1, Strdata, vbCrLf, CompareMethod.Text)
        WebGet.mHost = Trim(Mid(Strdata, iPart + 5, lPart - iPart - 5))
        ' Now we now need to get the Referer URL
        iPart = InStr(1, Strdata, "Referer:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        If iPart = 0 Or lPart = 0 Then
            WebGet.mReferer = ""
        Else
            WebGet.mReferer = Trim(Mid(Strdata, iPart + 8, lPart - iPart - 8))
            ' This gets the accept request
        End If

        iPart = InStr(1, Strdata, "Accept:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        WebGet.mAccept = Trim(Mid(Strdata, iPart + 7, lPart - iPart - 7))
        ' This gets the current language
        iPart = InStr(1, Strdata, "Accept-Language:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        WebGet.mAcceptLan = Trim(Mid(Strdata, iPart + 16, lPart - iPart - 16))
        ' This gets the current encoding type
        iPart = InStr(1, Strdata, "Accept-Encoding:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        WebGet.mEncoding = Trim(Mid(Strdata, iPart + 16, lPart - iPart - 16))
        ' Get the connection state
        iPart = InStr(1, Strdata, "Connection:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        WebGet.mConnection = Trim(Mid(Strdata, iPart + 11, lPart - iPart - 11))
        ' Get the content range
        iPart = InStr(1, Strdata, "Content-Range:")
        lPart = InStr(iPart, Strdata, vbCrLf)
        WebGet.mContentRange = Trim(Mid(Strdata, iPart + 14, lPart - iPart - 14))
        ' This will now get the Autorizantion value
        iPart = InStr(1, Strdata, "Authorization: ", CompareMethod.Text)
        lPart = InStr(iPart, Strdata, vbCrLf)
        If iPart > 0 And iPart > 0 Then Base64Str = Trim(Mid(Strdata, iPart + 15, lPart - iPart - 15))
        ' now to finish off we need to extract the base64 string
        iPart = InStr(1, Base64Str, Chr(32), CompareMethod.Text)
        WebGet.mAuthorization = Trim(Mid(Base64Str, iPart + 1, Len(Base64Str) - iPart))
        Base64Str = ""
        ' This gets any cookie stuff
        iPart = InStr(1, Strdata, "Cookie:")
        lPart = InStr(CShort(Strdata), CStr(iPart), vbCrLf)
        If iPart = 0 Or lPart = 0 Then
            WebGet.mCookie = ""
        Else
            WebGet.mCookie = Trim(Mid(Strdata, iPart + 7, lPart - iPart - 7))
        End If

        iPart = 0 : lPart = 0
        ' Below is used for getting form stuff this is not used in this ver.
        iPart = InStr(Strdata, "Content-Length: ")

        If iPart = 0 Then
            WebGet.mContentLen = 0
        Else
            ' This gets the forms data length
            WebGet.mContentLen = Val(CStr(CDbl(Mid(Strdata, iPart + 16, lPart - iPart - 16)) + 2))
            WebGet.mContentLen = Val(CStr(CDbl(Mid(Strdata, iPart + 16, lPart - iPart - 16)) + 2))


        End If
        iPart = 0 : lPart = 0

    End Function

    Public Function DecodeURL(ByRef TUrl As String) As String
        Dim iPart As Short
        Dim CGI_Str As String
        'This is used for decodeing web URLS
        While (InStr(TUrl, "%") <> 0)
            iPart = InStr(TUrl, "%")
            CGI_Str = Mid(TUrl, iPart + 1, 2)
            TUrl = Replace(TUrl, "%" & CGI_Str, Chr(CInt("&H" & CGI_Str)))
        End While
        DecodeURL = Replace(TUrl, "+", " ")
        iPart = 0
        CGI_Str = ""

    End Function

    Public ReadOnly Property Authorization() As String
        Get
            Authorization = WebGet.mAuthorization
        End Get
    End Property

    Public ReadOnly Property Host() As String
        Get
            Host = WebGet.mHost
        End Get
    End Property

    Public ReadOnly Property RequestType() As String
        Get
            RequestType = WebGet.mRequest
        End Get
    End Property

    Public ReadOnly Property URLReferer() As String
        Get
            URLReferer = WebGet.mReferer
        End Get
    End Property

    Public ReadOnly Property page() As String
        Get
            page = WebGet.mPage
        End Get
    End Property

    Public ReadOnly Property Language() As String
        Get
            Language = WebGet.mAcceptLan
        End Get
    End Property

    Public ReadOnly Property Encoding() As String
        Get
            Encoding = WebGet.mEncoding
        End Get
    End Property

    Public ReadOnly Property Connection() As String
        Get
            Connection = WebGet.mConnection
        End Get
    End Property

    Public ReadOnly Property HTTPVer() As String
        Get
            HTTPVer = WebGet.mHTTPVer
        End Get
    End Property
    Public ReadOnly Property Accept() As String
        Get
            Accept = WebGet.mAccept
        End Get
    End Property

    Public ReadOnly Property Agent() As String
        Get
            Agent = WebGet.mAgent
        End Get
    End Property

    Public ReadOnly Property ContentLen() As String
        Get
            ContentLen = CStr(WebGet.mContentLen)
        End Get
    End Property
    Public ReadOnly Property Cookie() As String
        Get
            Cookie = WebGet.mCookie
        End Get
    End Property

    Public ReadOnly Property FormData() As String
        Get
            FormData = WebGet.mFormData
        End Get
    End Property

    Public ReadOnly Property ContentRange() As String
        Get
            ContentRange = WebGet.mContentRange
        End Get
    End Property
End Class